base-4.9.1.0: Basic libraries

Copyright | (c) Ashley Yakeley 2007
License | BSD-style (see the LICENSE file in the distribution)
Maintainer | ashley@semantic.org
Stability | experimental
Portability | portable
Safe Haskell | Trustworthy
Language | Haskell2010

Control.Category

Description

Synopsis

- class Category cat where
- (<<<) :: Category cat => cat b c -> cat a b -> cat a c
- (>>>) :: Category cat => cat a b -> cat b c -> cat a c

# Documentation

class Category cat where Source #

A class for categories. id and (.) must form a monoid.

Minimal complete definition

id, (.)

Methods

id :: cat a a Source #

the identity morphism

(.) :: cat b c -> cat a b -> cat a c infixr 9 Source #

morphism composition

Instances

Category k (Coercion k) # |
Methods id :: cat a a Source # (.) :: cat b c -> cat a b -> cat a c Source #
Category k ((:~:) k) # |
Methods id :: cat a a Source # (.) :: cat b c -> cat a b -> cat a c Source #
Category * (->) # |
Methods id :: cat a a Source # (.) :: cat b c -> cat a b -> cat a c Source #
Monad m => Category * (Kleisli m) # |
Methods id :: cat a a Source # (.) :: cat b c -> cat a b -> cat a c Source #

(<<<) :: Category cat => cat b c -> cat a b -> cat a c infixr 1 Source #

Right-to-left composition

(>>>) :: Category cat => cat a b -> cat b c -> cat a c infixr 1 Source #

Left-to-right composition